import 'package:flutter/material.dart';
import 'package:flutter_custom_toolbox/flutter_toolbox.dart';

import 'package:spotifyplaylistgenerator/common/cubit/nav/nav_cubit_pages.dart';

import 'package:spotifyplaylistgenerator/cubit/activity/activity_cubit.dart';

class ApplicationConfig {
  static const String parameterCodePlaylistType = 'playlist-type';

  static const String playlistTypeArtists = 'artists';

  static final ApplicationConfigDefinition config = ApplicationConfigDefinition(
    appTitle: 'Spotify playlist generator',
    activitySettings: [
      // layout
      ApplicationSettingsParameter(
        code: parameterCodePlaylistType,
        values: [
          ApplicationSettingsParameterItemValue(
            value: playlistTypeArtists,
            isDefault: true,
          ),
        ],
      ),
    ],
    startNewActivity: (BuildContext context) {
      BlocProvider.of<ActivityCubit>(context).startNewActivity(context);
      BlocProvider.of<NavCubitPage>(context).goToPageHome();
    },
    deleteCurrentActivity: (BuildContext context) {
      BlocProvider.of<ActivityCubit>(context).deleteSavedActivity();
    },
    resumeActivity: (BuildContext context) {
      BlocProvider.of<ActivityCubit>(context).resumeSavedActivity();
      BlocProvider.of<NavCubitPage>(context).goToPageHome();
    },
  );
}
